% list of all neighboring pairs of 2D array elements that allow valid moves 

% KFB 01/26/03, 03/23/03
function l = array2_neighbors(a)

a1 = a(:,1);  a2 = a(:,2);
% generate neighbors of each element
a1new = array_neighbors(a1);  a2new = array_neighbors(a2);
a1diag = array_neighbors(a1,1);  a2diag = array_neighbors(a2,1);

% eliminate all elements of a1new that are neighbors of a2 (including diagonal neighbors)
s1 = ones(size(a1new));
for i=1:length(a1new)
    for j=1:length(a2diag)
        if array_equal(a1new{i},a2diag{j}), s1(i)=0; end
    end
end
a1new = a1new(find(s1));
% eliminate all elements of a2new that are neighbors of a1 (including diagonal neighbors)
s2 = ones(size(a2new));
for i=1:length(a2new)
    for j=1:length(a1diag)
        if array_equal(a2new{i},a1diag{j}), s2(i)=0; end
    end
end
a2new = a2new(find(s2));

% create pairs of new elements that represent new valid states
l = [];
for b1 = a1new
    b1n = array_neighbors(b1{1},1); % generate list of neighbors of b1, including diagonal neighbors
    for b2 = a2new
        if ~any(cell_ismember(b1n,b2{1},@array_equal)), % eliminate pair (b1 b2) if b2 is neighbor of b1
            l = [l {[b1{1},b2{1}]}]; 
        end
    end
end
