% list of all neighboring 2D array elements that allow valid moves
% while taking into account time-dependent obstacles

% KFB 02/29/04
function l = arrayP_neighbors(a)

global FIELD;

global PATH;
global TIME;

OLDFIELD = FIELD;                   % save field

% temporarily add higher priority moving objects as obstacles
t = TIME+1; % TIME=0 corresponds to obstacles listed in PATH{1}
NEWFIELD = zeros(size(FIELD));
if t <= length(PATH), 
    prior = PATH{t};
    for i=1:size(prior,2), NEWFIELD(prior(1,i),prior(2,i)) = 1; end
    if t+1 <= length(PATH), 
        prior = PATH{t+1};
        for i=1:size(prior,2), NEWFIELD(prior(1,i),prior(2,i)) = 1; end
    end
    FIELD = FIELD | filter2(ones(3),NEWFIELD,'same');   % add all moving objects plus their neighbors as obstacles
end

l = array_neighbors(a);             % determine permissible neighbors

FIELD = OLDFIELD;                   % restore field
