% KFB 02/29/04
% ICRA'04 figures

global FIELD;
M = 20;  N = 20;
FIELD = zeros(M,N);

%%%%% SHOW THIS ONE!
FIELD = zeros(M,N);
% figure(1); clf; 
FIELD(10:11,12:13) = 1;
path1 = astar_prioritized([10 10; 8 15]',[8 15; 10 10]',@arrayP_neighbors,@array_estimate,@array_equal);
if ~isempty(path1), celldisp(path1); end
figure(2); clf; show_path(path1);
figure(3); clf; show_path_steps(path1);

% test same conditions for line electrodes - NOT YET IMPLEMENTED!
figure(4); clf; 
FIELD(10:11,12:13) = 1;
path2 = astar_prioritized([10 10; 8 15]',[8 15; 10 10]',@arrayPlines_neighbors,@array_estimate,@array_equal);
if ~isempty(path2), celldisp(path2); end
figure(5); clf; show_path(path2);
figure(6); clf; show_path_steps(path2);

% Example 3 (revisited)
M = 6;  N = 6; 
FIELD = zeros(M,N);
% figure(1); clf; 
FIELD(5:6,3:4) = 1;
path1 = astar_prioritized([5 2; 4 5]',[4 5; 5 2]',@arrayP_neighbors,@array_estimate,@array_equal);
if ~isempty(path1), celldisp(path1); end
figure(2); clf; show_path(path1);
figure(3); clf; show_path_steps(path1);

% Figure 4, ICRA'04
% based on Figure 3, MEMS'04 abstract
% test random obstacles
M = 16;  N = 16;
% FIELD = rand(M,N)>0.8;
r = [1 4; 1 5; 1 6; 1 11;  2 5; 2 9; 2 10;  3 3; 3 7; 3 11;  4 1; 4 2; 4 6; 4 13; 4 16;  5 8;  6 2; 6 3; 6 8; 6 15;  7 1; 7 10; 7 11; 7 14;  8 6;  9 4; 9 11;  10 1; 10 2; 10 7; 10 9; 10 10; 10 14;  11 1; 11 10; 11 11; 11 12;  13 12; 13 15; 13 16;  14 13; 14 15;  15 4; 15 6;  16 6; 16 9; 16 11; 16 14]';
FIELD = zeros(M,N);  for i=1:size(r,2) FIELD(r(1,i),r(2,i))=1; end
START = [1 1; M 1; ceil(M/2) N; M ceil(N/2)]';
GOAL = [M N; 1 N; ceil(M/2) 1; 1 ceil(N/2)]';
FIELD(START(1,:),START(2,:)) = 0;
FIELD(GOAL (1,:),GOAL (2,:)) = 0;
tic;
path = astar_prioritized(START,GOAL,@arrayP_neighbors,@array_estimate,@array_equal);
toc;
% close all;
if ~isempty(path), 
    celldisp(path);
    figure(1); clf; show_path(path); xlabel('x'); ylabel('y'); 
    for i=1:size(START,2),
        % figure; 
        figure(i+1); clf; 
        show_path(path,i); xlabel('x'); ylabel('y'); drawnow; pause(0.1);  
    end
end