% KFB 08/13/03
% MEMS'04 figures

global FIELD;
M = 10;  N = 10;
FIELD = zeros(M,N);

figure(1); clf;
path = astar([2;2],[9;8],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
show_path(path);

% Figure 3
% test random obstacles
M = 20;  N = 20;
FIELD = rand(M,N)>0.7;
FIELD(1,1) = 0;  FIELD(M,N) = 0;
figure(1); clf;
figure(2); clf;
path = astar([1;1],[M;N],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
clf; show_path(path);

% Figure 1
FIELD = zeros(M,N);
FIELD(1:6,4) = 1;
FIELD(4:10,7) = 1;
figure(1); clf;
figure(2); clf;
path = astar([5;2],[5;9],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
clf; show_path(path);
colormap copper;

% Figure 2
FIELD = zeros(M,N);
figure(2); clf;
show_path([]);
droplet(2,2,0.5,1*pi/2,10);
droplet(8,8,0.5,1*pi/2,15);
droplet(8,2,0.4,0.8*pi/2,40);
droplet(1,4,0.4,0.8*pi/2,45);
droplet(1,8,0.4,0.9*pi/2,60);
droplet(4,10,0.4,0.9*pi/2,65);
colormap jet;
set(gca,'ZLim',[0 eps],'ZTick',[])

% Figure 4
FIELD = zeros(7,7);
figure(2); clf;
subplot(1,6,1);
show_path([]);
droplet(1,2,0.5,1*pi/2,10);
droplet(1,4,0.5,1*pi/2,10);
droplet(1,6,0.5,1*pi/2,10);
axis off;
subplot(1,6,2);
show_path([]);
droplet(2,2,0.5,1*pi/2,11);
droplet(2,4,0.5,1*pi/2,11);
droplet(2,6,0.5,1*pi/2,11);
axis off;
subplot(1,6,3);
show_path([]);
droplet(3,2,0.5,1*pi/2,12);
droplet(3,4,0.5,1*pi/2,12);
droplet(3,6,0.5,1*pi/2,12);
axis off;
subplot(1,6,4);
show_path([]);
droplet(1,2,0.5,1*pi/2,10);
droplet(1,4,0.5,1*pi/2,10);
droplet(1,6,0.5,1*pi/2,10);
droplet(4,2,0.5,1*pi/2,13);
droplet(4,4,0.5,1*pi/2,13);
droplet(4,6,0.5,1*pi/2,13);
axis off;
subplot(1,6,5);
show_path([]);
droplet(2,2,0.5,1*pi/2,11);
droplet(2,4,0.5,1*pi/2,11);
droplet(2,6,0.5,1*pi/2,11);
droplet(5,2,0.5,1*pi/2,14);
droplet(5,4,0.5,1*pi/2,14);
droplet(5,6,0.5,1*pi/2,14);
axis off;
subplot(1,6,6);
show_path([]);
droplet(3,2,0.5,1*pi/2,12);
droplet(3,4,0.5,1*pi/2,12);
droplet(3,6,0.5,1*pi/2,12);
droplet(6,2,0.5,1*pi/2,15);
droplet(6,4,0.5,1*pi/2,15);
droplet(6,6,0.5,1*pi/2,15);
axis off;

% Figure 5
FIELD = zeros(M,N);
figure(1); clf;
show_path([]);
droplet(2,2,0.5,1*pi/2,10);
droplet(8,2,0.4,0.8*pi/2,40);
droplet(1,8,0.4,0.9*pi/2,60);

droplet(2,3,0.5,1*pi/2,11);
droplet(7,2,0.4,0.8*pi/2,41);
droplet(1,9,0.4,0.9*pi/2,61);

droplet(2,4,0.5,1*pi/2,12);
droplet(6,2,0.4,0.8*pi/2,42);
droplet(1,10,0.4,0.9*pi/2,62);

droplet(3,4,0.5,1*pi/2,13);
droplet(5,2,0.4,0.8*pi/2,43);
droplet(2,10,0.4,0.9*pi/2,63);

droplet(4,4,0.5,1*pi/2,13);
droplet(4,2,0.4,0.8*pi/2,44);
droplet(3,10,0.4,0.9*pi/2,64);

droplet(4,5,0.5,1*pi/2,14);
droplet(3,2,0.4,0.8*pi/2,44);
droplet(3,10,0.4,0.9*pi/2,64);

% colormap jet;
% set(gca,'ZLim',[0 eps],'ZTick',[]);

%%% 4b
% figure(2); clf;
% show_path([]);
droplet(4,6,0.5,1*pi/2,15);
droplet(2,2,0.4,0.8*pi/2,45);
droplet(4,10,0.4,0.9*pi/2,65);

droplet(5,6,0.5,1*pi/2,16);
droplet(1,2,0.4,0.8*pi/2,46);

droplet(6,6,0.5,1*pi/2,17);
droplet(1,3,0.4,0.8*pi/2,47);

droplet(6,7,0.5,1*pi/2,18);
droplet(1,4,0.4,0.8*pi/2,48);

droplet(6,8,0.5,1*pi/2,19);
droplet(7,8,0.5,1*pi/2,20);
droplet(8,8,0.5,1*pi/2,21);

colormap jet;
set(gca,'ZLim',[0 eps],'ZTick',[]);