% KFB 01/26/03, 03/23/03, 03/31/03, 04/06/03

global FIELD;
M = 20;  N = 20;
FIELD = zeros(M,N);

figure(1); clf;
path = astar([2;2],[19;8],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
show_path(path);

figure(1); clf; figure(2); clf;
path = astar([1 1; 1 3]',[1 3; 1 1]',@array2_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
show_path(path);
% test same conditions for line electrodes 
figure(1); clf; figure(2); clf;
path = astar([1 1; 1 3]',[1 3; 1 1]',@array2lines_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
figure(3); clf; show_path_steps(path);

%%%%% SHOW THIS ONE!
FIELD = zeros(M,N);
figure(1); clf; 
FIELD(10:11,12:13) = 1;
path1 = astar([10 10; 8 15]',[8 15; 10 10]',@array2_neighbors,@array_estimate,@array_equal);
if ~isempty(path1), celldisp(path1); end
figure(2); clf; show_path(path1);
figure(3); clf; show_path_steps(path1);
% test same conditions for line electrodes 
figure(4); clf; 
FIELD(10:11,12:13) = 1;
path2 = astar([10 10; 8 15]',[8 15; 10 10]',@array2lines_neighbors,@array_estimate,@array_equal);
if ~isempty(path2), celldisp(path2); end
figure(5); clf; show_path(path2);
figure(6); clf; show_path_steps(path2);

figure(1); clf; figure(2); clf;
path = astar([1 1; M 1]',[M 1; 1 1]',@array2_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
clf; show_path(path);

%%%%%% SHOW THIS ONE!
% test random obstacles
FIELD = rand(M,N)>0.75;
FIELD(1,1) = 0;  FIELD(M,N) = 0;
figure(1); clf;
figure(2); clf;
path = astar([1;1],[M;N],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
clf; show_path(path);

% to profile the code:
% profile on
% <run code>
% profile off
% profile plot
% profile report

%%%%% uTAS 2003 abstract examples
% KFB 04/06/03
 
% Example 1
M = 10;  N = 10;
FIELD = zeros(M,N);
figure(1); clf;
% figure(2); clf;
path = astar([2;2],[M-1;N-1],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
show_path(path);  
set(gca,'ZTickLabel','','ZLim',[0 0.01]) % xlabel('x'); ylabel('y'); % axis off;

% Example 2
M = 10;  N = 10;
FIELD = rand(M,N)>0.7;  FIELD(2,2) = 0;  FIELD(M-1,N-1) = 0;
% figure(1); clf;
figure(2); clf; xlabel('x'); ylabel('y');
path = astar([2;2],[M-1;N-1],@array_neighbors,@array_estimate,@array_equal);
if ~isempty(path), celldisp(path); end
show_path(path); 

% Example 3
M = 6;  N = 6; 
FIELD = zeros(M,N);
% figure(1); clf; 
FIELD(5:6,3:4) = 1;
path1 = astar([5 2; 4 5]',[4 5; 5 2]',@array2_neighbors,@array_estimate,@array_equal);
if ~isempty(path1), celldisp(path1); end
figure(2); clf; show_path(path1);
figure(3); clf; show_path_steps(path1);

% Example 4 
% figure(4); clf; 
path2 = astar([5 2; 4 5]',[4 5; 5 2]',@array2lines_neighbors,@array_estimate,@array_equal);
if ~isempty(path2), celldisp(path2); end
figure(5); clf; show_path(path2);
figure(6); clf; show_path_steps(path2);
[rows,columns] = extract_rows_columns(path2);
for i=1:length(rows)
    subplot(3,4,i+1); r = rows{i};  c = columns{i};
    nr = length(r); % number of activated rows
    nc = length(c); % number of activated columns 

    line([1;1]*c(:)',[0.5;N+0.5]*ones(1,nc),'LineWidth',3,'Color','r');
    patch([1;1;1]*c(:)'+[-0.25;0;0.25]*ones(1,nc) , [N+1.5;N+0.5;N+1.5]*ones(1,nc),'r');
        
    lr = line([0.5;M+0.5]*ones(1,nr),[1;1]*r(:)','LineWidth',3,'Color','g');
    patch([M+1.5;M+0.5;M+1.5]*ones(1,nr), [1;1;1]*r(:)'+[-0.25;0;0.25]*ones(1,nr),'g');
end
