% Visualize A* search algrithm by plotting the visited nodes
% Figure 1 continuously plots all visited nodes if continuous=1 (default)
% Figure 2 plots currently visited nodes if current=1 (default)

% This is a simple function which assumes that element.node is an array of 2D coordinates

% KFB 03/14/03, 03/23/03
function dqueue_viz(element,priority,continuous,current)

global FIELD;
s = size(FIELD);  M = s(1);  N = s(2);

if exist('continuous')~=1, continuous=1; end;
if exist('current')~=1, current=1; end;

if continuous,
    figure(1);
    axis([0 M+1 0 N+1]); caxis([1,M+N-1]);
    for i=1:M, for j=1:N, if FIELD(i,j), patch([i-0.5 i+0.5 i+0.5 i-0.5],[j-0.5 j-0.5 j+0.5 j+0.5],'k'); end; end; end
    for i=1:size(element.node,2)
        x = element.node(1,i);  y = element.node(2,i);
        patch([x-0.5 x+0.5 x+0.5 x-0.5],[y-0.5 y-0.5 y+0.5 y+0.5],priority-element.value);
        text(x-0.5,y,sprintf('%c:%d',i+64,element.value),'FontSize',8);   % label nodes with A, B, C, ... (assuming char(65)='A') and value
    end
end

if current,
    figure(2); clf; 
    axis([0 M+1 0 N+1]); caxis([1,M+N-1]);
    for i=1:M, for j=1:N, if FIELD(i,j), patch([i-0.5 i+0.5 i+0.5 i-0.5],[j-0.5 j-0.5 j+0.5 j+0.5],'k'); end; end; end
    for i=1:size(element.node,2)
        x = element.node(1,i);  y = element.node(2,i);
        patch([x-0.5 x+0.5 x+0.5 x-0.5],[y-0.5 y-0.5 y+0.5 y+0.5],priority-element.value);
        text(x-0.5,y,sprintf('%c:%d',i+64,element.value),'FontSize',8);   % label nodes with A, B, C, ... (assuming char(65)='A') and value
    end
end
drawnow; pause(0.01);  
