% draw a partial sphere that resembles a droplet
%   (x,y) is the center of the droplet
%   r is its radius
%   alpha is its contact angle
%   c is the offset in the color index

% KFB 3/31/03
function d = droplet(x,y,r,alpha,c)
if exist('c')~=1, c=0; end
n = 50;                 % sampling of sphere surface
[X,Y,Z] = sphere(n);    % generate sphere surface
h = cos(alpha);         % vertical offset of sphere center
i = 1+round(alpha/pi*n);  if i==n+1, i=n; end   % remove lower parts of sphere 
X = X(i:n+1,:);  Y = Y(i:n+1,:);  Z = Z(i:n+1,:);  
X = r*X + x;  Y = r*Y + y;  Z = r*(Z+h);        % offset of droplet 
hold on;
d = surf(X,Y,Z,Z+c,'EdgeColor','none','FaceColor','interp');
% fill3([x-r x+r x+r x-r]',[y-r y-r y+r y+r]',[0 0 0 0],'w'); % square surface patch 
% colormap bone;
% axis equal;