% Determine the sequence of rows/columns that need to be activated
% to achieve the given path.

% KFB 04/06/03
function [rows,columns] = extract_rows_columns(p)

rows = [];  columns = [];
if length(p) > 0,
    el = p{1};
    k = size(el,2);
    x = el(1,:);  y = el(2,:);
    x_prev = x;  y_prev = y;
    for i=2:length(p)
        el = p{i};
        x = el(1,:);  y = el(2,:);
        r = [];  c = [];
        for j=1:k
            if (x(j)~=x_prev(j)) | (y(j)~=y_prev(j))
                c = [c x(j)];  r = [r y(j)]; 
            end
        end
        rows = [rows {r}];  columns = [columns {c}];
        x_prev = x;  y_prev = y;
    end
end
