% merge previously computed solutions in PATH with a new path

% KFB 2/29/04
function path_merge(newpath)

global PATH;

if isempty(newpath)
    % new solution path is empty, therefore the entire solution is empty
    PATH = [];  
elseif isempty(PATH)
    % no previous paths exist
    PATH = newpath; 
else
    % general case: merge previous paths with new path
    maxP = length(PATH);  maxp = length(newpath);
    for i = 1:max(maxP,maxp)
        % merge the two current nodes together
        if i <= maxP, PATHi = PATH{i}; end
        if i <= maxp, pathi = newpath{i}; end
        PATH{i} = [PATHi pathi];
    end
end
