% draw solution path

% KFB 03/22/03, 03/31/03, 04/06/03, 2/29/04
function show_path(p,n)

if exist('n')~=1, n = 0; end
    
global FIELD;
s = size(FIELD);  M = s(1);  N = s(2);
axis([0 M+1 0 N+1]); 
%% Option 1: simple square patches with numbers
% caxis([1,M+N-1]);
%% Option 2: droplets
colormap jet; % colormap bone; 
axis equal, view(3);
%% Option end
[X,Y] = meshgrid(0:M,0:N); mesh(X+0.5,Y+0.5,zeros(M+1,N+1));   
for i=1:M, for j=1:N, if FIELD(i,j), patch([i-0.5 i+0.5 i+0.5 i-0.5],[j-0.5 j-0.5 j+0.5 j+0.5],0.01*[1 1 1 1],'k'); end; end; end
axis equal;

px = [];  py = [];
for i=1:length(p)
    el = p{i};
    if n==0, range = 1:size(el,2); else range = n; end
    for j=range, 
        x = el(1,j);  y = el(2,j);
        px(i,j)=x;  py(i,j)=y; 
        %% Option 1: simple square patches with numbers
        % patch([x-0.5 x+0.5 x+0.5 x-0.5],[y-0.5 y-0.5 y+0.5 y+0.5],i);
        % text(x-0.5,y,sprintf('%c:%d',j+64,i),'FontSize',8);   % label nodes with A, B, C, ... (assuming char(65)='A') and number
        %% Option 2: droplets
        droplet(x,y,0.5,pi/2,i/length(p)+j/size(el,2));
        if n, text(x,y,0.5,sprintf('%d',i)); end
        %% Option end
    end
    drawnow; pause(0.1);  
end
line(px,py);