% draw solution path step by step

% KFB 03/22/03, 03/27/03, 03/31/03
function show_path_steps(p)

global FIELD;
s = size(FIELD);  M = s(1);  N = s(2);

% px = [];  py = [];
n = ceil(sqrt(length(p)));  m = ceil(length(p)/n);
for i=1:length(p)
    subplot(m,n,i);
    axis([0 M+1 0 N+1]); 
    %% Option 1: simple square patches with numbers
    % caxis([1,M+N-1]);
    %% Option 2: droplets
    colormap bone; axis equal; view(3);
    %% Option end
    [X,Y] = meshgrid(0:M,0:N); mesh(X+0.5,Y+0.5,zeros(M+1,N+1));   
    for ii=1:M, for jj=1:N, if FIELD(ii,jj), patch([ii-0.5 ii+0.5 ii+0.5 ii-0.5],[jj-0.5 jj-0.5 jj+0.5 jj+0.5],0.01*[1 1 1 1],'k'); end; end; end
    axis equal;
   
    el = p{i};
    for j=1:size(el,2), 
        x = el(1,j);  y = el(2,j);
        % px(i,j)=x; py(i,j)=y; 
        %% Option 1: simple square patches with numbers
        % patch([x-0.5 x+0.5 x+0.5 x-0.5],[y-0.5 y-0.5 y+0.5 y+0.5],i);
        % text(x-0.5,y,sprintf('%c:%d',j+64,i),'FontSize',8);   % label nodes with A, B, C, ... (assuming char(65)='A') and number
        %% Option 2: droplets
        droplet(x,y,0.5,pi/2,i/length(p)+j/size(el,2));
        %% Option end
    end
    % drawnow; pause(0.1);  
end
% line(px,py);